| 123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421 |
- #!/usr/bin/env bash
- # Copyright 2018 Google
- #
- # Licensed under the Apache License, Version 2.0 (the "License");
- # you may not use this file except in compliance with the License.
- # You may obtain a copy of the License at
- #
- # http://www.apache.org/licenses/LICENSE-2.0
- #
- # Unless required by applicable law or agreed to in writing, software
- # distributed under the License is distributed on an "AS IS" BASIS,
- # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- # See the License for the specific language governing permissions and
- # limitations under the License.
- # USAGE: build.sh product [platform] [method]
- #
- # Builds the given product for the given platform using the given build method
- function pod_gen() {
- # Call pod gen with a podspec and additional optional arguments.
- bundle exec pod gen --local-sources=./ --sources=https://cdn.cocoapods.org/ "$@"
- }
- set -euo pipefail
- if [[ $# -lt 1 ]]; then
- cat 1>&2 <<EOF
- USAGE: $0 product [platform] [method]
- product can be one of:
- Firebase
- Firestore
- InAppMessaging
- SymbolCollision
- platform can be one of:
- iOS (default)
- macOS
- tvOS
- method can be one of:
- xcodebuild (default)
- cmake
- Optionally, reads the environment variable SANITIZERS. If set, it is expected to
- be a string containing a space-separated list with some of the following
- elements:
- asan
- tsan
- ubsan
- EOF
- exit 1
- fi
- product="$1"
- platform="iOS"
- if [[ $# -gt 1 ]]; then
- platform="$2"
- fi
- method="xcodebuild"
- if [[ $# -gt 2 ]]; then
- method="$3"
- fi
- echo "Building $product for $platform using $method"
- if [[ -n "${SANITIZERS:-}" ]]; then
- echo "Using sanitizers: $SANITIZERS"
- fi
- scripts_dir=$(dirname "${BASH_SOURCE[0]}")
- firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
- # Runs xcodebuild with the given flags, piping output to xcpretty
- # If xcodebuild fails with known error codes, retries once.
- function RunXcodebuild() {
- echo xcodebuild "$@"
- xcodebuild "$@" | xcpretty; result=$?
- if [[ $result == 65 ]]; then
- echo "xcodebuild exited with 65, retrying" 1>&2
- sleep 5
- xcodebuild "$@" | xcpretty; result=$?
- fi
- if [[ $result != 0 ]]; then
- exit $result
- fi
- }
- ios_flags=(
- -sdk 'iphonesimulator'
- -destination 'platform=iOS Simulator,name=iPhone 7'
- )
- macos_flags=(
- -sdk 'macosx'
- -destination 'platform=OS X,arch=x86_64'
- )
- tvos_flags=(
- -sdk "appletvsimulator"
- -destination 'platform=tvOS Simulator,name=Apple TV'
- )
- # Compute standard flags for all platforms
- case "$platform" in
- iOS)
- xcb_flags=("${ios_flags[@]}")
- ;;
- macOS)
- xcb_flags=("${macos_flags[@]}")
- ;;
- tvOS)
- xcb_flags=("${tvos_flags[@]}")
- ;;
- all)
- xcb_flags=()
- ;;
- *)
- echo "Unknown platform '$platform'" 1>&2
- exit 1
- ;;
- esac
- xcb_flags+=(
- ONLY_ACTIVE_ARCH=YES
- CODE_SIGNING_REQUIRED=NO
- CODE_SIGNING_ALLOWED=YES
- COMPILER_INDEX_STORE_ENABLE=NO
- )
- # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
- # Right now, it makes the log overflow on Travis because many of our
- # dependencies don't build cleanly this way.
- cmake_options=(
- -Wdeprecated
- )
- xcode_version=$(xcodebuild -version | head -n 1)
- xcode_version="${xcode_version/Xcode /}"
- xcode_major="${xcode_version/.*/}"
- if [[ -n "${SANITIZERS:-}" ]]; then
- for sanitizer in $SANITIZERS; do
- case "$sanitizer" in
- asan)
- xcb_flags+=(
- -enableAddressSanitizer YES
- )
- cmake_options+=(
- -DWITH_ASAN=ON
- )
- ;;
- tsan)
- xcb_flags+=(
- -enableThreadSanitizer YES
- )
- cmake_options+=(
- -DWITH_TSAN=ON
- )
- ;;
- ubsan)
- xcb_flags+=(
- -enableUndefinedBehaviorSanitizer YES
- )
- cmake_options+=(
- -DWITH_UBSAN=ON
- )
- ;;
- *)
- echo "Unknown sanitizer '$sanitizer'" 1>&2
- exit 1
- ;;
- esac
- done
- fi
- case "$product-$method-$platform" in
- Firebase-xcodebuild-*)
- # Coverage collection often cause retries to fail because of partial
- # pre-existing data.
- # TODO(paulb777): Find a less blunt solution to this.
- rm -rf ~/Library/Developer/Xcode/DerivedData
- RunXcodebuild \
- -workspace 'Example/Firebase.xcworkspace' \
- -scheme "AllUnitTests_$platform" \
- "${xcb_flags[@]}" \
- build \
- test
- if [[ $platform == 'iOS' ]]; then
- # Code Coverage collection is only working on iOS currently.
- ./scripts/collect_metrics.sh 'Example/Firebase.xcworkspace' "AllUnitTests_$platform"
- # Test iOS Objective-C static library build
- cd Example
- sed -i -e 's/use_frameworks/\#use_frameworks/' Podfile
- pod update --no-repo-update
- cd ..
- RunXcodebuild \
- -workspace 'Example/Firebase.xcworkspace' \
- -scheme "AllUnitTests_$platform" \
- "${xcb_flags[@]}" \
- build \
- test
- fi
- ;;
- Auth-xcodebuild-*)
- if [[ "$TRAVIS_PULL_REQUEST" == "false" ||
- "$TRAVIS_PULL_REQUEST_SLUG" == "$TRAVIS_REPO_SLUG" ]]; then
- RunXcodebuild \
- -workspace 'Example/Auth/AuthSample/AuthSample.xcworkspace' \
- -scheme "Auth_ApiTests" \
- "${xcb_flags[@]}" \
- build \
- test
- fi
- ;;
- InAppMessaging-xcodebuild-iOS)
- RunXcodebuild \
- -workspace 'InAppMessaging/Example/InAppMessaging-Example-iOS.xcworkspace' \
- -scheme 'InAppMessaging_Example_iOS' \
- "${xcb_flags[@]}" \
- build \
- test
- cd InAppMessaging/Example
- sed -i -e 's/use_frameworks/\#use_frameworks/' Podfile
- pod update --no-repo-update
- cd ../..
- RunXcodebuild \
- -workspace 'InAppMessaging/Example/InAppMessaging-Example-iOS.xcworkspace' \
- -scheme 'InAppMessaging_Example_iOS' \
- "${xcb_flags[@]}" \
- build \
- test
- # Run UI tests on both iPad and iPhone simulators
- # TODO: Running two destinations from one xcodebuild command stopped working with Xcode 10.
- # Consider separating static library tests to a separate job.
- RunXcodebuild \
- -workspace 'InAppMessagingDisplay/Example/InAppMessagingDisplay-Sample.xcworkspace' \
- -scheme 'FiamDisplaySwiftExample' \
- "${xcb_flags[@]}" \
- build \
- test
- RunXcodebuild \
- -workspace 'InAppMessagingDisplay/Example/InAppMessagingDisplay-Sample.xcworkspace' \
- -scheme 'FiamDisplaySwiftExample' \
- -sdk 'iphonesimulator' \
- -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)' \
- build \
- test
- cd InAppMessagingDisplay/Example
- sed -i -e 's/use_frameworks/\#use_frameworks/' Podfile
- pod update --no-repo-update
- cd ../..
- # Run UI tests on both iPad and iPhone simulators
- RunXcodebuild \
- -workspace 'InAppMessagingDisplay/Example/InAppMessagingDisplay-Sample.xcworkspace' \
- -scheme 'FiamDisplaySwiftExample' \
- "${xcb_flags[@]}" \
- build \
- test
- RunXcodebuild \
- -workspace 'InAppMessagingDisplay/Example/InAppMessagingDisplay-Sample.xcworkspace' \
- -scheme 'FiamDisplaySwiftExample' \
- -sdk 'iphonesimulator' \
- -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)' \
- build \
- test
- ;;
- Firestore-xcodebuild-*)
- "${firestore_emulator}" start
- trap '"${firestore_emulator}" stop' ERR EXIT
- if [[ "$xcode_major" -lt 9 ]]; then
- # When building and testing for Xcode 8, only test unit tests.
- RunXcodebuild \
- -workspace 'Firestore/Example/Firestore.xcworkspace' \
- -scheme "Firestore_Tests_$platform" \
- "${xcb_flags[@]}" \
- build \
- test
- else
- # IntegrationTests run all the tests, including Swift tests, which
- # require Swift 4.0 and Xcode 9+.
- RunXcodebuild \
- -workspace 'Firestore/Example/Firestore.xcworkspace' \
- -scheme "Firestore_IntegrationTests_$platform" \
- "${xcb_flags[@]}" \
- build \
- test
- fi
- ;;
- Firestore-cmake-macOS)
- test -d build || mkdir build
- echo "Preparing cmake build ..."
- (cd build; cmake "${cmake_options[@]}" ..)
- echo "Building cmake build ..."
- cpus=$(sysctl -n hw.ncpu)
- (cd build; env make -j $cpus all generate_protos)
- (cd build; env CTEST_OUTPUT_ON_FAILURE=1 make -j $cpus test)
- ;;
- SymbolCollision-xcodebuild-*)
- RunXcodebuild \
- -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
- -scheme "SymbolCollisionTest" \
- "${xcb_flags[@]}" \
- build
- ;;
- Database-xcodebuild-*)
- pod_gen FirebaseDatabase.podspec --platforms=ios
- RunXcodebuild \
- -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
- -scheme "FirebaseDatabase-Unit-unit" \
- "${ios_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- if [[ "$TRAVIS_PULL_REQUEST" == "false" ||
- "$TRAVIS_PULL_REQUEST_SLUG" == "$TRAVIS_REPO_SLUG" ]]; then
- # Integration tests are only run on iOS to minimize flake failures.
- RunXcodebuild \
- -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
- -scheme "FirebaseDatabase-Unit-integration" \
- "${ios_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- fi
- pod_gen FirebaseDatabase.podspec --platforms=macos --clean
- RunXcodebuild \
- -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
- -scheme "FirebaseDatabase-Unit-unit" \
- "${macos_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- pod_gen FirebaseDatabase.podspec --platforms=tvos --clean
- RunXcodebuild \
- -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
- -scheme "FirebaseDatabase-Unit-unit" \
- "${tvos_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- ;;
- Storage-xcodebuild-*)
- pod_gen FirebaseStorage.podspec --platforms=ios
- RunXcodebuild \
- -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
- -scheme "FirebaseStorage-Unit-unit" \
- "${ios_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- if [[ "$TRAVIS_PULL_REQUEST" == "false" ||
- "$TRAVIS_PULL_REQUEST_SLUG" == "$TRAVIS_REPO_SLUG" ]]; then
- # Integration tests are only run on iOS to minimize flake failures.
- RunXcodebuild \
- -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
- -scheme "FirebaseStorage-Unit-integration" \
- "${ios_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- fi
- pod_gen FirebaseStorage.podspec --platforms=macos --clean
- RunXcodebuild \
- -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
- -scheme "FirebaseStorage-Unit-unit" \
- "${macos_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- pod_gen FirebaseStorage.podspec --platforms=tvos --clean
- RunXcodebuild \
- -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
- -scheme "FirebaseStorage-Unit-unit" \
- "${tvos_flags[@]}" \
- "${xcb_flags[@]}" \
- build \
- test
- ;;
- *)
- echo "Don't know how to build this product-platform-method combination" 1>&2
- echo " product=$product" 1>&2
- echo " platform=$platform" 1>&2
- echo " method=$method" 1>&2
- exit 1
- ;;
- esac
|